/*                  - Mellanox Confidential and Proprietary -
 *
 *  Copyright (C) 2010-2011, Mellanox Technologies Ltd.  ALL RIGHTS RESERVED.
 *
 *  Except as specifically permitted herein, no portion of the information,
 *  including but not limited to object code and source code, may be reproduced,
 *  modified, distributed, republished or otherwise exploited in any form or by
 *  any means for any purpose without the prior written permission of Mellanox
 *  Technologies Ltd. Use of software subject to the terms and conditions
 *  detailed in the file "COPYING".
 *
 */

#ifndef CC_MGR_API_H
#define CC_MGR_API_H


#ifdef __cplusplus
extern "C" {
#endif


/**
 * Create and initialize an instance of CongestionContorlManager
 *
 * @param p_osm pointer to osm object
 *
 * @return int 0 if succeeded, otherwise 1
 */
int initCCMgr(osm_opensm_t *p_osm,
        char *osm_plugin_options);


/**
 * Wrapper for Run in the CongestionContorlManager class
 * Update the osm event id
 * Run Congestion Control Manager
 *
 * @param p_osm pointer to osm object
 * @param osm_event_id osm event id
 *
 * @return int 0 if succeeded, otherwise 1
 */
int runCCMgr(osm_opensm_t *p_osm,
        osm_epi_event_id_t osm_event_id);


/**
 * Update the osm event id
 * Update the Congeston Control Manager Database
 *
 * @param p_osm pointer to osm object
 * @param osm_event_id osm event id
 *
 * @return int
 */
int updateCCMgr(osm_opensm_t *p_osm,
        osm_epi_event_id_t osm_event_id);


/**
 * Wrapper for SetOSMEventId in the CongestionContorlManager
 * class
 * Update the osm event id
 *
 * @param p_osm pointer to osm object
 * @param osm_event_id osm event id
 */
void setOSMEventIdCCMgr(osm_opensm_t *p_osm,
        osm_epi_event_id_t osm_event_id);


/**
 * Wrapper for Destructor in the CongestionContorlManager class
 *
 * @param p_osm pointer to osm object
 */
void destroyCCMgr(osm_opensm_t *p_osm);


#ifdef __cplusplus
} /* extern "C" */
#endif


#endif /* CC_MGR_API_H */
